// fdtools.h

#ifndef _FD_TOOLS_H_INCLUDED
#define _FD_TOOLS_H_INCLUDED
#include "filedisk.h"
typedef struct
{
    WCHAR           FileNameMount[MAX_PATH+0x10];
    BOOL            fReadOnly;
    LARGE_INTEGER   SizeMountedData;
} MOUNT_INFORMATION;

BOOL GetMountInfo(DWORD dwDrive,MOUNT_INFORMATION* pmi);
BOOL FileDiskUmount(char DriveLetter,DWORD &dwErr);
BOOL IsDriveAssigned(DWORD dwDrive);



typedef struct
{
    WCHAR           FileNameMount[MAX_PATH+0x10];
    BOOL            fCdRom;
    BOOL            fReadOnly;
    LARGE_INTEGER   SizeMountedData;


    LARGE_INTEGER   FileSize;
    LARGE_INTEGER   LimitImageSize;
    LARGE_INTEGER   ShiftImage;
    ULONG           SizeSector;
    ULONG           ShiftSector;
    ULONG           ExtraFlags;
} MOUNT_REQUEST_DETAIL;

typedef enum
{
    MOUNT_TYPE_ISO=1,
    MOUNT_TYPE_BIN,
    MOUNT_TYPE_DISKIMAGE
} MOUNT_TYPE;


typedef struct
{
    WCHAR           FileNameMount[MAX_PATH+0x10];
    BOOL            fFileNameNeedDDKTranslation;
    BOOL            fReadOnly;

    LARGE_INTEGER   FileSize;
    LARGE_INTEGER   LimitImageSize;
    LARGE_INTEGER   ShiftImage;
    MOUNT_TYPE      MountType;
} MOUNT_REQUEST_USER;

BOOL BuildFileNameMountDDK(LPWSTR lpDest,DWORD dwNbWCharBuf,LPCTSTR lpszFn);

BOOL FileDiskMount(int DeviceNumber,
                   POPEN_FILE_INFORMATION OpenFileInformation,
                   char DriveLetter,
                   BOOL CdImage,
                   DWORD &dwErrWin32);

BOOL FileDiskMountEx(int DeviceNumber,
                     POPEN_FILE_INFORMATION_EX OpenFileInformation,
                     char DriveLetter,
                     BOOL CdImage,
                     DWORD &dwErrWin32);

BOOL DoMountDetails(char DriveLetter,const MOUNT_REQUEST_DETAIL* pMrd,DWORD &dwErrWin32);
BOOL DoMount(char DriveLetter,const MOUNT_REQUEST_USER* pMru,DWORD &dwErrWin32);

BOOL CheckFileDiskInstalled();

BOOL GetFileDiskDriverInfo(QUERY_FILE_DISK_VERSION *pqfdv);
#endif
